<?php
/* utf8-marker = äöüß */
/*

CMSimple Guestbook plugin
© 2006-2010 - Joachim Barthel - www.qualifire.de/cmsimple/en
---------------------------------------------------------------------
Disclaimer:   No warranties at all, use on your own risk !
---------------------------------------------------------------------
Requirements: - CMSimple 2.5 is installed and running.
              - The plugin loader, version 1.0 beta 5 from  
                cmsimpleplugins.svarrer.dk is installed and working!
                -or-
              - The plugin loader, version 2.0 beta 9 from
                internet-setup.de/abdj_download/index.php is installed and working!  
---------------------------------------------------------------------
Feedback to:  jbarthel@qualifire.de
---------------------------------------------------------------------

Version 0.1 beta 0  (23. Feb. 2006)

Version 0.1 beta 1  (26. Feb. 2006)
  - Support for multilingual use
  - Enhancements of display
  - Support of CrLf in message
  - Storing of IP address

Version 0.1 beta 2  (14. March 2006)
  - No double entries on refresh
  - Text-Captcha for spam protections
  - Using CSS for displaying the entries

Version 0.1 beta 3  (19. March 2006)
  - Display of EMAIL and WEBSITE switchable
  - Option for removing HTML and SCRIPT elements
  - Full CSS support for colors
  - Splitting into pages

Version 0.1 beta 4  (24. March 2006)
  - support of french language (thanx to Gerd)
  - constant width of name column
  - Info-Mail for new entries
  - ignores empty lines

Version 0.1 beta 5a  (18. April 2006)
  - support of apostrophe (' and ")
  - checking of mandatory field (incl. white spaces)
  - beautified info email
  - enhanced Captcha
  - thanks email
  - switching on/off
  - support for php w/o bcmath

Version 0.1 beta 5b  (19. April 2006)
  - enhanced header() for MS IIS 

Version 0.1 beta 5c  (20. April 2006)
  - display of PHP errors (=white page problem)

Version 0.1 beta 5d  (30. April 2006)
  - enhanced handling of title field
  - support of slovak language (thanx to Martin Sereday)

Version 0.6 beta (September 2006)
  - new folder 'images' for the bitmaps
  - all functions renamed to gb_nnnnnnn to avoid conflicts with other plugins
  - function gb_Version() added
  - support of danish language (thanx to Per Kongebro)
  - support of finish language (thanx to Ahti Kurki)
  - support of dutch language (thanx to Gerd Xhonneux)
  - support of portuguese language (thanx to JoaoVr)
  - import function for original CMSimple guestbook
  - avoid error on empty lines in guestbook file
  - support of multiple guestbooks per language
  - new CSS file for green colored websites

Version 0.6a beta (10. October 2006)
  - corrected captcha (pure ascii)
  - another fix for empty guestbooks

Version 0.7 beta (26. December 2006)
  - corrected config.php (spam_words and show_creator were missing)
  - predefined guestbooks for DA, FI, IT, NL, PT, SK added
  - Quick link in info e-mail
  - Missing guestbook file will be created by plugin
  - Link to QualiFIRE now optionally
  - support of italian language (thanx to Sandro Cavalieri Foschini)
  - support of norwegian language (thanx to Tobias Michel)
  - enhanced page navigation (esp. for many pages)
  - options for showing e-mail, website and ip-address
  - e-mail can optionally be mandatory
  - simple encrypting of e-mail addresses (thanx to Eric Levermann)
  - enhanced formatting of input fields through css support
  - removed old entries from css files
  - corrected display of first entry/last page (in some cases not displayed)
  - checking for correct e-mail
  - storing of ip address now optionally
  - protection of the content folder with .htaccess
  - adjustable width of message textarea
  - option for lower case captcha
  - enhanced captcha transfer
  - support of smileys (multicolor icons & insert function)
  - reorg function for datafile
  - info e-mail as html mail

Version 0.7a beta (03. January 2007)
  - corrected french language file (thanx to BoB)

Version 0.8 beta (20. March 2007)
  - block list for IP addresses
  - block words against spam
  - block list for countries (based on www.phptutorial.info/iptocountry)
  - optionally one guestbook for all languages
  - support of hungarian language (thanx to Zsolt Kádas)
  - correction of error on checking e-mail (when it is not mandatory), thanx to Flo
  - config text "blocked_words" used instead of "spam_words"
  - support of &print mode of cmsimple (no page splitting)
  - optional quarantine time for new messages

Version 0.8a beta (1. April 2007)
  - error correction for single ip addresses in list of blocked ip'S
  
Patch 0.8b beta (28. June 2008)
  - changed captcha for blocking "doris" spam
  
Patch 0.8c (03. June 2008)
  - additional graphical captcha, again because of "doris" spam

  Version 0.8.1 beta  (3. October 2007 / not released)
  - better support of missing guestbook file
  - empty directory include
  - misspelled word in translation corrected
  - support of common guestbook in administration
  - better display of quarantine times less than 1 hour
  - checking of language variables
  - checking of configuration variables

Version 0.8.2 beta  (21. February 2008)
  - support of slovenian (=SI) language (thanx to Mantas Garuckas)
  - predefined guestbooks for SI added (thanx to Mantas Garuckas)
  - corrected file of dutch (=NL) language (thanx to Bas van Duijnhoven)
  - support of polish (=PL) language (thanx to ...)
  - support of cmsimple 3.0
  - checking of IP-files existence added
  - fixed problems with #CMSimple ...# in the text
  - setting numeric_captcha for numbers only in captcha
  - updated installation guide
  - optionally online checking of version
  - changed captcha for blocking "doris"
  - additional graphical captcha, again because of "doris" spam
  - support of russian (=RU) language (thanx to XXXXXXXXXXX)

Version 0.8.3 beta  (20. February 2010)
  - additional fields for ZIP and CITY
  - optional display of city
  - problem with quarantine time = 0 fixed

Version 0.8.4 beta 1 (22. August 2010)
  - Text corrections in admin
  - support of multiple guestbooks in admin
  - deleting entries in admin area
  - editing entries in admin area

Version 0.8.4 beta 2 (24. August 2010)
  - Corrections in language files
  
Version 0.8.4 beta 3 (09. November 2010)
  - Corrections in editing guestbook files
    
### Mod v0.1 by Pinoccio (Oct. 2010) ###
  - input form redesign (table layout) + css
  - captcha picture modified
  - added Cancel button in form  
  - messages from Admin (identified by special qualifier in name field) are highligted
  - added simple bbcode support + hints page (multilanguage support)
  - limit max. message size (characters) + counter of remaining characters
  - guestbook rules hint (link to a hint page, multilanguage support)
  - optional hint to a FAQ page (to reduce repeated questions)
  - some html validity problems solved
  - oher minor changes...

### Mod v0.2 by Pinoccio (Feb. 2012) ###
  - now based on gbook084beta3 + my previous changes
  - utf-8 encoding
  - xhtml (valid)
  - kept simple text editing of contents in admin (as addition to the new option per-record with form)
  - other minor corrections and changes...
 
### Mod v0.3 by Pinoccio (Feb. 2012) ###
  - resolved security issue with potential injection (notice from Christoph B., thanks)
  - added omitted config variables
 
### Mod v0.3a by Pinoccio (Feb. 2012) ###
  - fixed problem with conversion of htmlentities
  - emails have corrected header because of utf-8
  - emails have text with linebreaks to make them better readable if html is not displayed (unfortunately not always working)
  - updated content files which were not utf-8 in previous version

### Mod v0.4 by Pinoccio (Feb. 2012) ###
  - true _XH (valid html/xhtml according to config)
  - fixed problem with conversion of htmlentities in emails
  - variable 'blocked_countries' is skipped in the config check (no warnings if empty anymore)
  - bbcode functionality injection threat solved
  - solved problem with links to hints & rules if installed in 'nonstandard' directory
  - new hints for config variables + corrected some typos in language files
  - other minor corrections and changes...
 
### Mod v0.5 beta by Pinoccio (Mar. 2012) ###
  - replaced deprecated php functions (ereg*, split, ...)
  - admin: fixed functionality - handling previously added internal replacement substring '|~' for encoded htmlentities
  - admin: import guestbook & records editing have now implemented utf-8 conversion and htmlentities en/de-coding (!only slightly tested yet)
  - admin: resolved some more issues (unwanted empty lines) when editing and deleting records
  - minor graphical change in capcha image
  - some code cleanup (internal)

  TODO: Problem with raw text editing in admin - all htmlentities lose their coding when placed in a textarea,
        the original character will be displayed instead (rawedit is virtually unusable with htmlentities!).
        This has to be solved probably in the plugin loader functions... added config option to disable rawedit for now.
        Details: when the file contents are displayed in the textarea, htmlentities are shown as characters - even without the trailing semicolon
        (which was internally replaced by an escape sequence '|~'), so the character is shown along with the escape sequence (that's wrong).
        When the file is saved, characters will replace the original htmlentity (that's wrong) and the escape sequence is left also (wrong too).
        Is there a way how to force the textarea not to translate 'incomplete ' htmlentities?
*/

require_once("include/bbcode.php"); //bbcode encoding

/* returns GBook version
*/
function gb_Version() {
   return "0.8.4 beta 3";
}

/* returns Mod version
*/
function gb_ModVersion() {
   return "v0.5 beta";
}

/* (MAIN) GBook plugin main function
*/
function gblist($gb_filename) {
   GLOBAL $su, $sl, $plugin_cf, $plugin_tx, $pth, $plugin, $sn;

   if (!isset($gb_filename)) $gb_filename = "guestbook";
   $t = "";
   $gbname = isset($_POST['gbname']) ? $_POST['gbname'] : $_GET['gbname'];
   $gbemail = isset($_POST['gbemail']) ? $_POST['gbemail'] : $_GET['gbemail'];
   $gbwebsite = isset($_POST['gbwebsite']) ? $_POST['gbwebsite'] : $_GET['gbwebsite'];
   $gbtitle = isset($_POST['gbtitle']) ? $_POST['gbtitle'] : $_GET['gbtitle'];
   $gbzip = isset($_POST['gbzip']) ? $_POST['gbzip'] : $_GET['gbzip'];
   $gbcity = isset($_POST['gbcity']) ? $_POST['gbcity'] : $_GET['gbcity'];
   $gbmessage = isset($_POST['gbmessage']) ? $_POST['gbmessage'] : $_GET['gbmessage'];
   $gbpublish = isset($_POST['gbpublish']) ? $_POST['gbpublish'] : $_GET['gbpublish'];
   $gbpage = isset($_POST['page']) ? $_POST['page'] : $_GET['page'];
   $gboption = isset($_POST['option']) ? $_POST['option'] : $_GET['option'];
   if (intval($gbpage)==0) $gbpage=1;
   
   if($gboption != '')
     return gb_returnContents($gboption);

   $plugin = basename(dirname(__FILE__),"/");
   if(stripos($plugin_cf['gbook']['common_guestbook'], "true") !== false) {
      $gbfile = $pth['folder']['plugins'].$plugin."/content/" . $gb_filename . ".txt";
   } else {
      $gbfile = $pth['folder']['plugins'].$plugin."/content/" . $gb_filename . "_".$sl.".txt";
   }
   $imgpath = $pth['folder']['plugins']."gbook/images/";
   $gb_nlines = gb_CountLines($gbfile);
   if(stripos($plugin_cf['gbook']['captcha'], "true") !== false) {
      $gbcc = isset($_POST['gbcc']) ? $_POST['gbcc'] : $_GET['gbcc'];
   } else {
      $gbcc = gb_CreateTextCaptcha($gb_nlines);
   }

   $replacer = "|~"; //warning, do not play with this ;)
   if(!empty($plugin_cf['gbook']['semicolon_replacer_sequence']))
     if(strlen($plugin_cf['gbook']['semicolon_replacer_sequence']) > 1)
       $replacer = $plugin_cf['gbook']['semicolon_replacer_sequence'];

   //error_reporting(E_ALL);

   if(stripos($plugin_cf['gbook']['debug'], "true") !== false) {
      echo tag('br')."------------------------------------------".tag('br');
      echo "gbfile = " . $gbfile . tag('br');
      echo "captcha = " . $gbcc . tag('br');
      echo "ip = " . $_SERVER["REMOTE_ADDR"];
      echo tag('br')."------------------------------------------".tag('br');
   }
   
   $abortcode = 0;
   
   if(stripos($plugin_cf['gbook']['check_version'], "true") !== false) {
      gb_chkVersionOnline();
   }
   
   if(stripos($plugin_cf['gbook']['debug'], "true") !== false) {
      echo tag('br')."------------------------------------------".tag('br');
      echo $_SERVER["REMOTE_ADDR"];
      echo tag('br')."------------------------------------------".tag('br');
   }
   if ($gbcc <> gb_CreateTextCaptcha($gb_nlines)) $abortcode = $abortcode | 1;
   if ((gb_chkBlockedWords($gbtitle) || gb_chkBlockedWords($gbmessage)) == true) $abortcode = $abortcode | 2;
   if (gb_chkBlockedIPs($_SERVER["REMOTE_ADDR"]) == true) $abortcode = $abortcode | 4;
   if (gb_chkBlockedDomains($_SERVER["REMOTE_ADDR"]) == true) $abortcode = $abortcode | 8;
   if (gb_chkBlockedCountries($_SERVER["REMOTE_ADDR"]) == true) $abortcode = $abortcode | 16;
   if (strlen($gbmessage) > $plugin_cf['gbook']['message_max_chars']) $abortcode = $abortcode | 32;
   

   if($gbname && $gbmessage) {

      if ($abortcode == 0) {
         $gbwebsite = preg_replace("/http:\/\//i","",$gbwebsite);
         $gbname = gb_RemoveHtml($gbname);
         $gbemail = gb_RemoveHtml($gbemail);
         $gbwebsite = gb_RemoveHtml($gbwebsite);
         $gbzip = gb_RemoveHtml($gbzip);
         $gbcity = gb_RemoveHtml($gbcity);
         //$gbtitle = str_replace(";",",", $gbtitle);
         $gbtitle = gb_RemoveHtml($gbtitle);
    		 if (empty($gbpublish))
    			$gbpublish = 'no';
    		 else
    			$gbpublish = 'yes';

         if(stripos($plugin_cf['gbook']['remove_html'], "true") !== false) {
            $gbmessage = gb_RemoveHtml($gbmessage);
         }
         $gbmessage = gb_conv2Smileys($gbmessage);

         $gbmessage = str_replace(chr(13).chr(10),tag('br'),$gbmessage);
         $gbmessage = str_replace(chr(13),tag('br'),$gbmessage);
         $gbmessage = str_replace(chr(10),tag('br'),$gbmessage);
         //$gbmessage = str_replace(";",",",$gbmessage);
         $gbipaddr = (stripos($plugin_cf['gbook']['store_ip_addr'], "true") !== false) ? $_SERVER["REMOTE_ADDR"] : "";

         if (!$fp = fopen($gbfile, 'a+')) {
            $t .= tag('br').tag('hr')."ERROR: Cannot open file ($gbfile)".tag('hr').tag('br');
         } else {
//echo "start ---------".tag('br');
            $gbentry = "\n" . $gbname .";". $gbemail .";". $gbwebsite .";". date($plugin_cf['gbook']['time_format']) .";". date($plugin_cf['gbook']['date_format']) .";". $gbtitle .";". $gbmessage .";". $gbipaddr .";". mktime() .";" . $gbzip . ";" . $gbcity . ";" . $gbpublish;
            if (fputs($fp,$gbentry) == FALSE)
               $t.=tag('br')."ERROR: Cannot write to file ($gbfile)";
            fclose($fp);
            $gb_nlines++;
            // preg_match("/^[_a-z0-9-]+(\.[_a-z0-9-]+)*@[_a-z0-9-]+(\.[_a-z0-9-]+)*(\.([a-z]{2,4}))+$/i",$gbemail)
            if (isset($plugin_cf['gbook']['info_mail']) && stripos($plugin_cf['gbook']['info_mail'], "true") !== false &&
                isset($plugin_cf['gbook']['info_mail_to']) && !$plugin_cf['gbook']['info_mail_to']=="") {
//echo "in send info-mail ---------".tag('br');
               $mailbody = str_replace($replacer,";", $gbname) . " " . $plugin_tx['gbook']['txt_email_wrote'] . ":".tag('br')."\n";
               $mailbody .= str_repeat("-", strlen($mailbody)) .tag('br').tag('br')."\n\n";
               if (!$gbtitle == "") $mailbody .= str_replace($replacer,";", $gbtitle) .tag('br').tag('br')."\n\n";
               $mailbody .= ($plugin_cf['gbook']['allow_bbcode'] == True ? bbcode_format(str_replace($replacer,";", $gbmessage), false) : str_replace($replacer,";", $gbmessage)) .tag('br').tag('br')."\n\n";
               $gblink = "http://" . $_SERVER['HTTP_HOST'] . $_SERVER['PHP_SELF'] . "?" . $_SERVER['QUERY_STRING']; 
               $mailbody .= "<a href=\"$gblink\">$gblink</a>".tag('br')."\n";
               //$mailbody = str_replace(tag('br'),tag('br')."\n",$mailbody);
               //$mailbody = html_entity_decode($mailbody, ENT_QUOTES | ENT_XHTML, 'UTF-8'); //TODO: in case mail not in html format
               @mail(
                  $plugin_cf['gbook']['info_mail_to'],
                  '=?UTF-8?B?'.base64_encode("NEW: ".gb_restoreHtml($gbtitle)).'?=', //TODO: language specific prefix in subject
                  $mailbody,
                  "From: Gbook_".$sl."@{$_SERVER['SERVER_NAME']}\r\n"
                  ."MIME-Version: 1.0\r\n"
                  ."Content-Type: text/html; charset=UTF-8\r\n"
                  ."Content-Transfer-Encoding: 8bit/html\r\n"
                  ."X-Mailer: PHP/" . phpversion());
            }

            if (stripos($plugin_cf['gbook']['thank_mail'], "true") !== false && (!$gbemail == "")) {
               $mailbody = sprintf(preg_replace('/'.str_replace('/','\/',tag('br')).'/i',tag('br')."\n",$plugin_tx['gbook']['txt_thankmail_body']), str_replace($replacer,";", $gbname), $_SERVER['SERVER_NAME']) . "\n";
               @mail(
                  $gbemail,
                  '=?UTF-8?B?'.base64_encode($plugin_tx['gbook']['txt_thankmail_subject']).'?=',
                  $mailbody,
                  "From: ".$plugin_cf['gbook']['thank_sendfrom']."\r\n"
                  ."MIME-Version: 1.0\r\n"
                  ."Content-Type: text/html; charset=UTF-8\r\n"
                  //."Reply-To: ".$plugin_cf['gbook']['thank_sendfrom']."\r\n"
                  ."X-Mailer: PHP/" . phpversion());
            }

//echo "Location: http://" . $_SERVER['HTTP_HOST'] . $_SERVER['PHP_SELF'] . "?" . $_SERVER['QUERY_STRING'];
            header("Location: http://" . $_SERVER['HTTP_HOST'] . $_SERVER['PHP_SELF'] . "?" . $_SERVER['QUERY_STRING']);
            exit;
         }

      } else {
         $t .= tag('br')."<div style=\"border: 1px solid red;padding:2px;\"><ul>";
         if (($abortcode & 1) == 1) $t .= "<li>" . $plugin_tx['gbook']['txt_wrong_captcha'] . "</li>";
         if (($abortcode & 2) == 2) $t .= "<li>" . $plugin_tx['gbook']['txt_spam_found'] . "</li>";
         if (($abortcode & 4) == 4) $t .= "<li>" . $plugin_tx['gbook']['txt_blocked_ip'] . "</li>";
         if (($abortcode & 8) == 8) $t .= "<li>" . $plugin_tx['gbook']['txt_blocked_domain'] . "</li>";
         if (($abortcode & 16) == 16) $t .= "<li>" . $plugin_tx['gbook']['txt_blocked_country'] . "</li>";
         if (($abortcode & 32) == 32) $t .= "<li>" . $plugin_tx['gbook']['txt_message_limit'] . " (max. " . $plugin_cf['gbook']['message_max_chars'] . ")</li>";
         $t .= "</ul></div>";
      }
   }

   $t .= "<!-- QualiFIREs Guestbook >>GBook<< Code starts here -->\n<div>".tag('br')."\n";

   $t .= "<script language=\"javascript\" type=\"text/javascript\">\n";
   $t .= "/* <![CDATA[ */\n";
   //$t .= "<!--\n";
   $t .= "function gb_showDetail(iNum) {\n";
   $t .= "var IDName;\n";
   $t .= "IDdetail = 'detail' + iNum;\n";
   $t .= "IDanchor = 'anchor' + iNum;\n";
   $t .= "if (document.getElementById(IDdetail).style.display.indexOf('block') == -1) {\n";
   $t .= "document.getElementById(IDdetail).style.display = \"block\";\n";
   $t .= "document.getElementById(IDanchor).style.display = \"none\";\n";
   if (stripos($plugin_cf['gbook']['captcha'], "true") !== false) {
      $t .= "document.gbook.gbcc.focus();\n";
   } else {
      $t .= "document.gbook.gbname.focus();\n";
   }
   $t .= "} else {\n";
   $t .= "document.getElementById(IDdetail).style.display = \"none\";\n";
   $t .= "document.getElementById(IDanchor).style.display = \"block\";\n";
   $t .= "}\n";
   $t .= "}\n";

   if (stripos($plugin_cf['gbook']['image_captcha'], "true") === false) {
      $t .= "function gb_showCC(){\n";

      $t .= "return deRot(unescape(\"";
      $tcc = gb_CreateTextCaptcha($gb_nlines);
      for ($i=0; $i<6; $i++)
         $t .= '%'. dechex(ord(gb_rot13(substr($tcc,$i,1))));
      $t .= "\"));\n";
      $t .= "}\n";
   
      $t .= "function deRot(sCode) {\n";
      $t .= "var key =\"ABCDEFGHIJKLMNOPQRSTUVWXYZ\";\n";
      $t .= "txtRot = new String()\n";
      $t .= "for(var i = 0; i < sCode.length; i++) {\n";
      $t .= "var codechar	= sCode.substring(i, i + 1)\n";
      $t .= "var pos = key.indexOf(codechar.toUpperCase())\n";
      $t .= "if(pos >= 0) {\n";
      $t .= "pos = (pos + key.length / 2) % key.length\n";
      $t .= "codechar = (codechar == codechar.toUpperCase()) ? ";
      $t .= "key.substring(pos, pos + 1) : ";
      $t .= "key.substring(pos, pos + 1).toLowerCase()\n";
      $t .= "}\n";
      $t .= "txtRot = txtRot + codechar\n";
      $t .= "}\n";
      if (phpversion() >= "4.2")
         $t .= "return txtRot;\n";
      else
         $t .= "return sCode;\n";
      $t .= "}\n";
   }

   $t .= "function gb_checkForm() {\n";
   $t .= "document.gbook.gbcc.style.border = '1px solid #bbb';\n";
   $t .= "document.gbook.gbname.style.border = '1px solid #bbb';\n";
   $t .= "document.gbook.gbemail.style.border = '1px solid #bbb';\n";
   $t .= "document.gbook.gbtitle.style.border = '1px solid #bbb';\n";
   $t .= "document.gbook.gbwebsite.style.border = '1px solid #bbb';\n";
   $t .= "document.gbook.gbzip.style.border = '1px solid #bbb';\n";
   $t .= "document.gbook.gbcity.style.border = '1px solid #bbb';\n";
   $t .= "document.gbook.gbmessage.style.border = '1px solid #bbb';\n";
   if(stripos($plugin_cf['gbook']['captcha'], "true") !== false) {
      $t .= "if (document.gbook.gbcc.value.replace(/\s+/g,'') == '') {\n";
      $t .= "document.gbook.gbcc.style.border = 'red 1px solid';\n";
      $t .= "document.gbook.gbcc.focus();\n";
      $t .= "alert('" . $plugin_tx['gbook']['txt_mandatory_alert'] . "');\n";
      $t .= "return false;\n";
      $t .= "}\n";
   }
   $t .= "if (document.gbook.gbname.value.replace(/\s+/g,'') == '') {\n";
   $t .= "document.gbook.gbname.style.border = 'red 1px solid';\n";
   $t .= "document.gbook.gbname.focus();\n";
   $t .= "alert('" . $plugin_tx['gbook']['txt_mandatory_alert'] . "');\n";
   $t .= "return false;\n";
   $t .= "}\n";
   if((stripos($plugin_cf['gbook']['mandatory_email'], "true") !== false) && (stripos($plugin_cf['gbook']['ask_for_email'], "true") !== false)) {
      $t .= "if (document.gbook.gbemail.value.replace(/\s+/g,'') == '') {\n";
      $t .= "document.gbook.gbemail.style.border = 'red 1px solid';\n";
      $t .= "document.gbook.gbemail.focus();\n";
      $t .= "alert('" . $plugin_tx['gbook']['txt_mandatory_alert'] . "');\n";
      $t .= "return false;\n";
      $t .= "}\n";
   }
    if (stripos($plugin_cf['gbook']['ask_for_email'], "true") !== false) {
      $t .= "if ((gb_checkEMA(document.gbook.gbemail.value) == false) && (document.gbook.gbemail.value.replace(/\s+/g,'') != '')) {\n";
      $t .= "document.gbook.gbemail.style.border = 'red 1px solid';\n";
      $t .= "document.gbook.gbemail.focus();\n";
      $t .= "alert('" . $plugin_tx['gbook']['txt_incorrect_email'] . "');\n";
      $t .= "return false;\n";
      $t .= "}\n";
   }
   if((stripos($plugin_cf['gbook']['mandatory_website'], "true") !== false) && (stripos($plugin_cf['gbook']['ask_for_website'], "true") !== false)) {
      $t .= "if (document.gbook.gbwebsite.value.replace(/\s+/g,'') == '') {\n";
      $t .= "document.gbook.gbwebsite.style.border = 'red 1px solid';\n";
      $t .= "document.gbook.gbwebsite.focus();\n";
      $t .= "alert('" . $plugin_tx['gbook']['txt_mandatory_alert'] . "');\n";
      $t .= "return false;\n";
      $t .= "}\n";
   }
   if((stripos($plugin_cf['gbook']['mandatory_zipncity'], "true") !== false) && (stripos($plugin_cf['gbook']['ask_for_zipncity'], "true") !== false)) {
      $t .= "if ((document.gbook.gbzip.value.replace(/\s+/g,'') == '') || (document.gbook.gbcity.value.replace(/\s+/g,'') == '')) {\n";
      $t .= "document.gbook.gbzip.style.border = 'red 1px solid';\n";
      $t .= "document.gbook.gbcity.style.border = 'red 1px solid';\n";
      $t .= "document.gbook.gbzip.focus();\n";
      $t .= "alert('" . $plugin_tx['gbook']['txt_mandatory_alert'] . "');\n";
      $t .= "return false;\n";
      $t .= "}\n";
   }
   if((stripos($plugin_cf['gbook']['mandatory_title'], "true") !== false) && (stripos($plugin_cf['gbook']['ask_for_title'], "true") !== false)) {
      $t .= "if (document.gbook.gbtitle.value.replace(/\s+/g,'') == '') {\n";
      $t .= "document.gbook.gbtitle.style.border = 'red 1px solid';\n";
      $t .= "document.gbook.gbtitle.focus();\n";
      $t .= "alert('" . $plugin_tx['gbook']['txt_mandatory_alert'] . "');\n";
      $t .= "return false;\n";
      $t .= "}\n";
   }
   $t .= "if (document.gbook.gbmessage.value.replace(/\s+/g,'') == '') {\n";
   $t .= "document.gbook.gbmessage.style.border = 'red 1px solid';\n";
   $t .= "document.gbook.gbmessage.focus();\n";
   $t .= "alert('" . $plugin_tx['gbook']['txt_mandatory_alert'] . "');\n";
   $t .= "return false;\n";
   $t .= "}\n";
   $t .= "}\n";

   $t .= "function gb_checkEMA(sEMail) {\n";
   $t .= "var res = false;\n";
   /*
   $t .= "if(typeof(RegExp) == 'function') {\n";
   $t .= "var b = new RegExp('abc');\n";
   $t .= "if(b.test('abc') == true) {a = true;}\n";
   $t .= "}\n";
   $t .= "if(a == true) {\n";
   //$t .= "reg = new RegExp('^([a-zA-Z0-9\\-\\.\\_]+)' + '(\\@)([a-zA-Z0-9\\-\\.]+)' + '(\\.)([a-zA-Z]{2,4})$');\n";
   $t .= "reg = new RegExp('^[_a-z0-9-]+(\.[_a-z0-9-]+)*@[_a-z0-9-]+(\.[_a-z0-9-]+)*(\.([a-z]{2,4}))+$');\n";
   $t .= "res = reg.test(sEMail);\n";
            $t .= "alert('sEMail = '+sEMail);";
            $t .= "alert('res = '+res);";
   $t .= "} else {\n";
   */
   $t .= "res = (sEMail.search('@') >= 1 && sEMail.lastIndexOf('.') > sEMail.search('@') && sEMail.lastIndexOf('.') >= sEMail.length-5)\n";
   //$t .= "}\n";
   $t .= "return(res);\n";
   $t .= "}\n";


   //Remaining characters counter
   $t .= "function taLimit(taObj, evt) {\n";
	 $t .= "  if (taObj.value.length>=" . $plugin_cf['gbook']['message_max_chars'] . ") {\n";
	 $t .= "    var keycode = (evt.keyCode==0) ? evt.which : evt.keyCode\n";
	 $t .= "    if (keycode != 8 && keycode != 46) return false;\n"; //allow backspace and delete
   $t .= "  }\n";
	 $t .= "  return true;\n";
   $t .= "}\n";

   $t .= "function taCount(taObj,Cnt) {\n";
   $t .= "	objCnt=createObject(Cnt);\n";
   $t .= "	objVal=taObj.value;\n";
   $t .= "	if (objVal.length>" . $plugin_cf['gbook']['message_max_chars'] . ") objVal=objVal.substring(0," . $plugin_cf['gbook']['message_max_chars'] . ");\n";
   $t .= "	if (objCnt) {";
   $t .= "		if(navigator.appName == \"Netscape\"){\n";
   $t .= "			objCnt.textContent=" . $plugin_cf['gbook']['message_max_chars'] . "-objVal.length;}\n";
   $t .= "		else{objCnt.innerText=" . $plugin_cf['gbook']['message_max_chars'] . "-objVal.length;}\n";
   $t .= "	}\n";
   $t .= "	return true;\n";
   $t .= "}\n";

   $t .= "function createObject(objId) {\n";
   $t .= "	if (document.getElementById) return document.getElementById(objId);\n";
   $t .= "	else if (document.layers) return eval(\"document.\" + objId);\n";
   $t .= "	else if (document.all) return eval(\"document.all.\" + objId);\n";
   $t .= "	else return eval(\"document.\" + objId);\n";
   $t .= "}\n";

   $t .= "function insertText(chrField, chrValue) {\n";
   //IE support
   $t .= "var objField = document.getElementsByName(chrField)[0];\n";  //document.getElementById(chrField);\n";
   $t .= "if (document.selection) {\n";
   $t .= "objField.focus();\n";
   $t .= "sel = document.selection.createRange();\n";
   $t .= "sel.text = chrValue;\n";
   $t .= "}\n";
   //MOZILLA/NETSCAPE/FIREFOX support
   $t .= "else if (objField.selectionStart || objField.selectionStart == '0') {\n";
   $t .= "var startPos = objField.selectionStart;\n";
   $t .= "var endPos = objField.selectionEnd;\n";
   $t .= "objField.value = objField.value.substring(0, startPos) + chrValue + objField.value.substring(endPos, objField.value.length);\n";
   $t .= "} else {\n";
   $t .= "objField.value += chrValue;\n";
   $t .= "}\n";
   $t .= "objField.focus();\n";
   $t .= "taCount(objField,'myCounter');\n"; //TODO: not very nice solution
   $t .= "}\n";

   //display popup window
   $t .= "function gb_showWin(fileName) {\n";
   $t .= " var link = '" . $sn . "?" . $_SERVER['QUERY_STRING'] . "&option=' + fileName + '&print';\n";
   $t .= " var infoWin = window.open(link, 'PopupWin', 'location=no, menubar=no, height=350, width=600, resizable=yes, toolbar=no, scrollbars=1');\n";
   $t .= " infoWin.focus();\n";
   $t .= "}\n";

   $t .= "/* ]]> */\n";
   //$t .= "//-->\n";
   $t .= "</script>\n";

   if(isset($plugin_cf['gbook']['chceck_config']) && stripos($plugin_cf['gbook']['chceck_config'], "true") !== false) {
     $t .= gb_chkLangVars();
     $t .= gb_chkConfigVars();
   }

   if(stripos($plugin_cf['gbook']['show_faq_hint'], "true") !== false)
     $t .= "<span style=\"font-size: 115%; color: rgb(190, 0, 45);\">" . $plugin_tx['gbook']['txt_read_faq'] . "</span> <span style=\"font-size: 115%;\">\"<a href=\"./?" . $plugin_cf['gbook']['faq_page_name'] . "\">" . $plugin_tx['gbook']['txt_read_faq_b'] . "</a>\".</span>".tag('p')."\n";

   if(stripos($plugin_cf['gbook']['new_entries'], "true") !== false) {
      $t .= "<div id=\"anchor1\" style=\"font-size:120%;\"><a href=\"javascript:gb_showDetail(1)\">".$plugin_tx['gbook']['txt_newentry'] . "</a>".tag('br')."&nbsp;".tag('br')."</div>";
   } else {
      $t .= $plugin_tx['gbook']['txt_offline_hint'];
   }
   
   if (file_exists($pth['folder']['plugins']."sfilter/index.php")){
      // $t .= tag('br')."--- SFilter installed ---".tag('br');
   }

   //$tSpace = "<div style=\"border-top: 3px solid transparent; width: 40%; margin-top: 2px;\"></div>";
   $t .= "\n<div id=\"detail1\" style=\"display: none;\">".tag('hr');
   $t .= "\n<form name=\"gbook\" onsubmit=\"return gb_checkForm();\" method=\"post\" action=\"?".$su."\">";
   $t .= "\n<table width=\"100%\" cellspacing=\"1\" cellpadding=\"0\">";
   if(stripos($plugin_cf['gbook']['captcha'], "true") !== false) {
      $t .= "\n<tr><td>" . $plugin_tx['gbook']['txt_captcha'];
	  if(stripos($plugin_cf['gbook']['image_captcha'], "true") !== false) {
	     if (stripos($plugin_cf['gbook']['numeric_captcha'], "true") !== false) {
		      $capParam = 'N';
		   } else {
		      $capParam = 'A';
       }
	     if (stripos($plugin_cf['gbook']['ucase_captcha'], "true") !== false) {
	        $capParam .= 'U';
	     } else {
	        $capParam .= 'L';
	     }
	     $capParam .= $gb_nlines;
	     $t .= " ".tag('img style="position: relative; top:3px; border: 1px solid #DCE6F0;" src="' . $pth['folder']['plugins'] . $plugin . '/include/qlib/image.php?param='.$capParam.'" alt="captcha"')."</td>";
	  } else {
	     $t .= " <strong><script language=\"javascript\" type=\"text/javascript\">document.write(gb_showCC());</script></strong>" . "</td>";
      }
      $t .= "<td>".tag('input name="gbcc" type="text" class="gbcaptcha textinput" size="8" maxlength="6"')." *</td></tr>";
   }
   $t .= "\n<tr><td>" . $plugin_tx['gbook']['txt_name'] . ": </td>" . "<td style=\"padding-bottom: 1px;\">".tag('input name="gbname" type="text" class="gbtextbox textinput" size="40" maxlength="80"')." *</td></tr>";
   if(stripos($plugin_cf['gbook']['ask_for_email'], "true") !== false) {
      $t .= "\n<tr><td>" . $plugin_tx['gbook']['txt_email'] . ": </td>" . "<td>".tag('input name="gbemail" type="text" class="gbtextbox textinput" size="40" maxlength="80"');
      if(stripos($plugin_cf['gbook']['mandatory_email'], "true") !== false) $t .= " *";
      $t .= "</td></tr>";
   } else {
      $t .= "\n<tr><td colspan=\"2\">".tag('input name="gbemail" type="hidden" size="40" maxlength="80"')."</td></tr>";
   }
   if(stripos($plugin_cf['gbook']['ask_for_website'], "true") !== false) {
      $t .= "\n<tr><td>" . $plugin_tx['gbook']['txt_website'] . ": </td>" . "<td>".tag('input name="gbwebsite" type="text" class="gbtextbox textinput" size="40" maxlength="80"')."</td></tr>";
   } else {
      $t .= "\n<tr><td colspan=\"2\">".tag('input name="gbwebsite" type="hidden" size="40" maxlength="80"')."</td></tr>";
   }
   if(stripos($plugin_cf['gbook']['ask_for_zipncity'], "true") !== false) {
    $t .= "\n<tr><td>" . $plugin_tx['gbook']['txt_city'] . ": </td>" . "<td>".tag('input name="gbcity" type="text" class="gbtextbox textinput" size="28" maxlength="60"');
    if(stripos($plugin_cf['gbook']['mandatory_zipncity'], "true") !== false) $t .= " *";
    $t .= "</td></tr>";
	  $t .= "\n<tr><td>" . $plugin_tx['gbook']['txt_zip'] . ": </td>" . "<td>".tag('input name="gbzip" type="text" class="gbtextbox textinput" size="7" maxlength="10"');
	  if(stripos($plugin_cf['gbook']['mandatory_zipncity'], "true") !== false) $t .= " *";
    $t .= "</td></tr>";
   } else {
      $t .= "\n<tr><td colspan=\"2\">".tag('input name="gbzip" type="hidden" class="gbtextbox" size="5" maxlength="10"')."</td></tr>";
      $t .= "\n<tr><td colspan=\"2\">".tag('input name="gbcity" type="hidden" class="gbtextbox" size="35" maxlength="60"')."</td></tr>";
   }
   if(stripos($plugin_cf['gbook']['ask_for_title'], "true") !== false) {
      $t .= "\n<tr><td>" . $plugin_tx['gbook']['txt_title'] . ": </td>" . "<td>".tag('input name="gbtitle" type="text" class="gbtextbox textinput" size="40" maxlength="80"');
      if(stripos($plugin_cf['gbook']['mandatory_title'], "true") !== false) $t .= " *";
      $t .= "</td></tr>";
   } else {
      $t .= "\n<tr><td colspan=\"2\">".tag('input name="gbtitle" type="hidden" size="40" maxlength="80"')."</td></tr>";
   }
   $t .= "\n<tr><td colspan=\"2\" height=\"3\" style=\"font-size:1%;\">&nbsp;</td></tr>" . "\n<tr><td>" . $plugin_tx['gbook']['txt_message'] . ": *</td>";
   $t .= "<td align=\"right\">";
   if(stripos($plugin_cf['gbook']['use_smileys'], "true") !== false) $t .= gb_smileyToolbar();
   $t .= " &nbsp;</td></tr>";
   $t .= "\n<tr><td colspan=\"2\"><textarea rows=\"6\" cols=\"" . $plugin_cf['gbook']['message_width'] . "\" class=\"gbmsgbox textinput\" name=\"gbmessage\" onkeypress=\"return taLimit(this, event);\" onkeyup=\"return taCount(this,'myCounter');\"></textarea></td></tr>";
//-//   $t .= "<input type=\"hidden\" name=\"gbtoken\" value=\"" . md5(uniqid(mt_rand())) . "\">";
   if(stripos($plugin_cf['gbook']['ask_for_publishing'], "true") !== false) {
      $t .= "<tr><td><label for=\"gbpublish\">" . $plugin_tx['gbook']['txt_publishing'] . "</label></td><td>".tag('input name="gbpublish" id="gbpublish" type="checkbox" class="gbtextbox" size="40" maxlength="80"')."</td></tr>";
   } else {
      $t .= "\n<tr><td colspan=\"2\">".tag('input name="gbpublish" type="hidden" size="40" maxlength="80"')."</td></tr>";
   }
   $t .= "\n<tr><td><small><b><a href=\"javascript:gb_showWin('" . $plugin_tx['gbook']['rules_page'] . "');\">" . $plugin_tx['gbook']['txt_rules'] . "</a></b>";
   if(stripos($plugin_cf['gbook']['allow_bbcode'], "true") !== false && stripos($plugin_cf['gbook']['show_bbcode_hint'], "true") !== false) {
     $t .= " &nbsp; <a href=\"javascript:gb_showWin('" . $plugin_tx['gbook']['bbcode_page'] . "');\">" . $plugin_tx['gbook']['txt_bbcode'] . "</a>";
   }
   $t .= "</small></td>";
   $t .= "<td align=\"right\"><small>" . $plugin_tx['gbook']['max_chars_hint'] . " <b><span id=\"myCounter\">" . $plugin_cf['gbook']['message_max_chars'] . "</span></b></small>&nbsp;&nbsp;</td></tr>";
   $t .= "\n<tr><td colspan=\"2\" height=\"5\" style=\"font-size:1%;\">&nbsp;</td></tr>";
   $t .= "\n<tr><td>".tag('input type="submit" style="cursor:pointer;background-color:#C1C1C1;border:#444444 1px solid;" value="' . $plugin_tx['gbook']['btn_submit'] . '"');
   $t .= "&nbsp;&nbsp;".tag('input type="button" style="cursor:pointer;background-color:#C1C1C1;border:#444444 1px solid;" onclick="gb_showDetail(1);" value="' . $plugin_tx['gbook']['btn_cancel'] . '"')."</td>";
   $t .= "<td align=\"right\">* = " . $plugin_tx['gbook']['txt_mandatory_hint'] . " &nbsp;</td></tr>";
//-//   $t .= "\n<tr><td colspan=\"2\">".tag('input type="hidden" name="gbtoken" value="' . md5(uniqid(mt_rand())) . '"')."</td></tr>";
   $t .= "\n</table></form>";
   $t .= "\n".tag('hr').tag('br')."</div>\n";

   if(is_file($gbfile)){
      $fp = fopen($gbfile, "r");
      $tl = "";
      $lineCount = 0;
      $gbNameArray = array();
      $gbEmailArray = array();
      $gbWebsiteArray = array();
      $gbTimeArray = array();
      $gbDateArray = array();
      $gbZipArray = array();
      $gbCityArray = array();
      $gbTitleArray = array();
      $gbMessageArray = array();
      $gbIpaddrArray = array();
      $gbTStampArray = array();
      $gbPublishArray = array();
      $gbname = '';
      $gbemail = '';
      $gbwebsite = '';
      $gbtime = '';
      $gbdate = '';
      $gbzip = '';
      $gbcity = '';
      $gbtitle = '';
      $gbmessage = '';
      $gbipaddr = '';
      $gbtstamp = '';
      $gbpublish = '';

      $asrctxt = array (chr(92).chr(34),
                        chr(92).chr(39),
                        chr(10).chr(13),
                        chr(13),
                        chr(10),
                        $replacer); //replace back for entities

      $areptxt = array (chr(34),
                        chr(39),
                        "",
                        "",
                        "",
                        ";");

      while (!feof($fp)) {
         $line = fgets($fp, 4096) . ";";
         @list($gbname,$gbemail,$gbwebsite,$gbtime,$gbdate,$gbtitle,$gbmessage,$gbipaddr,$gbtstamp,$gbzip,$gbcity,$gbpublish) = preg_split("/;/", $line);
         //$line = fgets($fp, 4096);
         //@list($gbname,$gbemail,$gbwebsite,$gbtime,$gbdate,$gbtitle,$gbmessage,$gbipaddr) = preg_split("/;/", $line);
         if ((empty($gbtitle)) && (empty($gbmessage))) {
            // do nothing
         } else {
            array_push($gbNameArray, str_replace($asrctxt, $areptxt, $gbname));
            array_push($gbEmailArray, str_replace($asrctxt, $areptxt, $gbemail));
            array_push($gbWebsiteArray, str_replace($replacer, ";",$gbwebsite)); //replace only entities
            array_push($gbTimeArray, $gbtime);
            array_push($gbDateArray, $gbdate);
            array_push($gbTitleArray, str_replace($asrctxt, $areptxt, $gbtitle));
            array_push($gbMessageArray, str_replace($asrctxt, $areptxt, $gbmessage));
            array_push($gbIpaddrArray, str_replace($asrctxt, $areptxt, $gbipaddr));
            array_push($gbTStampArray, $gbtstamp);
            array_push($gbZipArray, $gbzip);
            array_push($gbCityArray, str_replace($asrctxt, $areptxt, $gbcity));
            array_push($gbPublishArray, $gbpublish);

            $lineCount++;
         }
      }
      $lineCount--;
      fclose($fp);
   } else {
      $lineCount = -1;
   }

   if (stripos($_SERVER['QUERY_STRING'], "&print") === false) {
      $startNum = $lineCount - intval($gbpage-1) * intval($plugin_cf['gbook']['items_per_page']);
      $endNum = $startNum - intval($plugin_cf['gbook']['items_per_page']) + 1.0;
   } else {
      $startNum = $lineCount;
      $endNum = 0;
   }
   if ($endNum < 0) $endNum = 0;

   $tl = "";
   for ($i = $startNum; $i >= $endNum; $i--) {
      //find admin qualifier if applicable and replace it
      $admin_message = false;
      $titleClass = "gbtitle";
      if(strlen($plugin_cf['gbook']['admin_name_qualifier']) > 0)
      {
        $pos = strpos($gbNameArray[$i], $plugin_cf['gbook']['admin_name_qualifier']);
        if($pos === false)
          $admin_message = false;
        else
        {
          $admin_message = true;
          $titleClass = "gbtitleadmin";
          $gbNameArray[$i] = str_replace($plugin_cf['gbook']['admin_name_qualifier'], "", $gbNameArray[$i]);
        }
      }

      if (gb_Modulo($i,2) == 0) {
        if($admin_message == true)
          $lineClass = "gbadminlightline";
        else
          $lineClass = "gblightline";
      } else {
        if($admin_message == true)
          $lineClass = "gbadmindarkline";
        else
          $lineClass = "gbdarkline";
      }

      if($plugin_cf['gbook']['allow_bbcode'] == True)
      {
        $gbMessageArray[$i] = bbcode_format($gbMessageArray[$i], false);
      }

      $tm = "";
      $tm .= "<table width=\"100%\" cellpadding=\"4\" cellspacing=\"1\" bgcolor=\"#666666\" border=\"0\">\n";
      if ($gbTitleArray[$i] != '') $tm .= "<tr><td colspan=\"2\" class=\"" . $titleClass . "\">" . gb_showSmileys($gbTitleArray[$i]) . "</td></tr>\n";
      $tm .= "<tr>";
      $tm .= "<td width=\"15%\" class=\"" . $lineClass . "\" valign=\"top\"><div class=\"gbname\" title=\"".$gbNameArray[$i]."\">" . $gbNameArray[$i] . "&nbsp;</div>";
      if (stripos($plugin_cf['gbook']['show_zipncity'], "true") !== false) 
        $tm .= "<span class=\"gbdatetime\">" . $gbCityArray[$i] . "</span>".tag('br');
      $tm .= "<span class=\"gbdatetime\">" . $gbDateArray[$i] . ", " . $gbTimeArray[$i] . "</span>".tag('br');
      if (($gbEmailArray[$i] != '') && (stripos($plugin_cf['gbook']['show_email'], "true") !== false)) 
        $tm .= "<a href=\""
          . "&#109;&#97;&#105;&#108;&#116;&#111;&#58;" . gb_EncMail($gbEmailArray[$i]) 
          . "\">".tag('img src="'.$imgpath.'email.png" border="0" alt="email.png" title="' . gb_EncMail($gbEmailArray[$i]) . '"')."</a>&nbsp;";
      if (($gbWebsiteArray[$i] != '') && (stripos($plugin_cf['gbook']['show_website'], "true") !== false)) $tm .= "<a href=\"http://" . $gbWebsiteArray[$i] . "\" target=\"_blank\">".tag('img src="'.$imgpath.'website.png" border="0" alt="website.png" title="' . $gbWebsiteArray[$i] . '"')."</a>&nbsp;";
      if ((stripos($plugin_cf['gbook']['show_ip_addr'], "true") !== false) && (stripos($plugin_cf['gbook']['store_ip_addr'], "true") !== false))
         if ($_SERVER["SERVER_NAME"] == "localhost") {
            $tm .= tag('img src="'.$imgpath.'machine.png" border="0" alt="machine.png" title="' . $gbIpaddrArray[$i] . ' = localhost'  . '"')."&nbsp;";
         } else {
            $tm .= tag('img src="'.$imgpath.'machine.png" border="0" alt="machine.png" title="' . $gbIpaddrArray[$i] . ' = ' . @gethostbyaddr($gbIpaddrArray[$i]) . '"')."&nbsp;";
         }
      $tm .= "</td>";
      //$gbMessageArray[$i] = gb_showSmileys($gbMessageArray[$i]);
      //$gbMessageArray[$i] = gb_chkQuarantine($gbMessageArray[$i],$gbTStampArray[$i]);
      $tm .= "<td class=\"" . $lineClass . "\" valign=\"top\"><span class=\"gbmessage\">" . gb_chkQuarantine(gb_showSmileys($gbMessageArray[$i]),$gbTStampArray[$i]) . "&nbsp;</span></td>";
      //$tm .= "<TD class=\"" . $lineClass . "\" valign=\"top\"><span class=\"gbmessage\">" . gb_showSmileys($gbMessageArray[$i]) . "&nbsp;</span></TD>";
      $tm .= "</tr>\n";
      $tm .= "</table>".tag('br')."\n";

      $tl .= $tm;
   }

   $t .= $tl;

   $lineCount++;

   if (stripos($_SERVER['QUERY_STRING'], "&print") === false)
      $t .= gb_DispPageNav(intval($gbpage), $lineCount)."\n";

   if(stripos($plugin_cf['gbook']['show_creator'], "true") !== false) {
      $t .= "<div style=\"text-align: center; font-size: 0.75em; display: block\">";
   } else {
      $t .= "<div style=\"text-align: center; font-size: 0.75em; display: none\">";
   }

   $t .= tag('br')."&nbsp;".tag('br')."<span style=\"border-top: 1px solid; padding-top: 2px; color:#666666;\">&nbsp;&nbsp;&nbsp;Guestbook plugin, Ver. " . gb_version() . " by ";
   if ($sl == "de") {
      $t .= "<a href=\"http://www.qualifire.de/cmsimple\" target=\"_blank\">";
   }
   else {
      $t .= "<a href=\"http://www.qualifire.de/cmsimple/en\" target=\"_blank\">";
   }
   $t .= "QualiFIRE</a>, Mod " .gb_ModVersion() . " by <a href=\"http://www.pinoccio.webz.cz\" target=\"_blank\">Pinoccio</a>&nbsp;&nbsp;</span>";
   $t .= "</div>\n";

   $t .= "</div>";
   $t .= "\n<!-- QualiFIREs Guestbook >>GBook<< Code ends here -->\n";

   return $t;
}


/* Generates page navigation
*/
function gb_DispPageNav($actPage, $totalLines) {
	GLOBAL $su, $sl, $plugin_cf, $plugin_tx, $pth, $plugin;

	$tNav = "";
	$linesPerPage = intval($plugin_cf['gbook']['items_per_page']);
	$actPage = intval($actPage);
	$firstPage = 1;
	$lastPage = gb_Div($totalLines, $linesPerPage);
	$numOfPages = intval($plugin_cf['gbook']['num_of_pages']);

	if (gb_Modulo($totalLines, $linesPerPage) > 0) $lastPage++;

	$tNav .= "<div style=\"text-align: center;\">";
	if ($actPage > 1) {
		$tNav .= "<a href=\"?" . $su . "&amp;page=" . intval($firstPage) . "\">" . $plugin_tx['gbook']['lnk_first_page'] . "</a>&nbsp;&nbsp;&nbsp;";
		if(stripos($plugin_cf['gbook']['show_narrowlink'], "true") !== false) 
			$tNav .= "<a href=\"?" . $su . "&amp;page=" . intval($actPage-1) . "\">" . $plugin_tx['gbook']['lnk_prev_page'] . "</a>&nbsp;&nbsp;&nbsp;";
		if($actPage-$numOfPages > $firstPage)
			$tNav .= ".&nbsp;.&nbsp;.&nbsp;&nbsp;&nbsp;";
		for ($i = max($firstPage,$actPage-$numOfPages); $i < $actPage; $i++) 
			$tNav .= "<a href=\"?" . $su . "&amp;page=" . intval($i) . "\">" . intval($i) . "</a>&nbsp;&nbsp;&nbsp;"; 
	}
	
	$tNav .= "<b>" . intval($actPage) . "</b>&nbsp;&nbsp;&nbsp;";

	if ($actPage+1 <= $lastPage) {
		for ($i = $actPage+1; $i <= min($lastPage,$actPage+$numOfPages); $i++) 
			$tNav .= "<a href=\"?" . $su . "&amp;page=" . intval($i) . "\">" . intval($i) . "</a>&nbsp;&nbsp;&nbsp;"; 
		if($actPage+$numOfPages < $lastPage)
			$tNav .= ".&nbsp;.&nbsp;.&nbsp;&nbsp;&nbsp;";
		if(stripos($plugin_cf['gbook']['show_narrowlink'], "true") !== false) 
			$tNav .= "<a href=\"?" . $su . "&amp;page=" . intval($actPage+1) . "\">" . $plugin_tx['gbook']['lnk_next_page'] . "</a>&nbsp;&nbsp;&nbsp;";
		$tNav .= "<a href=\"?" . $su . "&amp;page=" . intval($lastPage) . "\">" . $plugin_tx['gbook']['lnk_last_page'] . "</a>";
	}
	$tNav .= "</div>";

	return $tNav;
}


/* Creates text code for captcha
*/
function gb_CreateTextCaptcha($lineCount) {
	 GLOBAL $su, $sl, $plugin_cf, $plugin_tx, $pth, $plugin;

   $t = "";
   $gbGuestIP = $_SERVER["REMOTE_ADDR"];
   $gbGuestIP = intval(substr($gbGuestIP,strrpos($gbGuestIP,".")+1));
   $gbServerIP = $_SERVER["REMOTE_ADDR"];
   $gbServerIP = intval(substr($gbServerIP,strrpos($gbServerIP,".")+1));
   $t .= gb_MakeCaptChar(date("d")*($gbGuestIP+$lineCount));
   $t .= gb_MakeCaptChar(date("m")*$gbGuestIP*gb_CrossFoot($lineCount));
   $t .= gb_MakeCaptChar(date("z")*$gbGuestIP*$lineCount);
   $t .= gb_MakeCaptChar((date("w")+11)*$gbGuestIP*gb_CrossFoot($lineCount));
   $t .= gb_MakeCaptChar(date("W")*($gbGuestIP+$lineCount));
   $t .= gb_MakeCaptChar($gbGuestIP*$lineCount*$gbServerIP);
   if(stripos($plugin_cf['gbook']['ucase_captcha'], "true") === false)
      $t = strtolower($t);

   return $t;
}


/*
*/
function gb_EncMail($mailaddr) {
   $cem = "";
   for($i=0; $i<strlen($mailaddr); $i++) {
      if(substr($mailaddr,$i,1)!="@" && substr($mailaddr,$i,1)!=".")
         $cem .= "&#" . ord(substr($mailaddr,$i,1)) . ";";
      else
         $cem .= substr($mailaddr,$i,1);
   }
   return $cem;
}


/*
*/
function gb_MakeCaptChar($nVal) {
   GLOBAL $su, $sl, $plugin_cf, $plugin_tx, $pth, $plugin;

   if(stripos($plugin_cf['gbook']['numeric_captcha'], "true") !== false) {
      $nSmlVal = gb_Modulo($nVal,10);
   } else {
      $nSmlVal = gb_Modulo($nVal,36);
   }
   if ($nSmlVal < 10) {
      // 1..9 = '0'..'9'
      $cchar = chr($nSmlVal+48);
   } else {
      // 10..35 = 'A'..'Z'
      $cchar = chr($nSmlVal+55);
   }

   return $cchar;
}


/* Count lines
*/
function gb_CountLines ($gbfile){
   $lineCount = 0;
   if(is_file($gbfile)){
      $fp = fopen($gbfile, "r");
      $lineCount = 0;

      while (!feof($fp)) {
         $line = fgets($fp, 4096) . ";";
         if (empty($line)) {
            // do nothing
         } else {
            $lineCount++;
         }
      }
      $lineCount--;
      fclose($fp);
   }
   return $lineCount;
}


/*
*/
function gb_Modulo($vop, $vmod) {
   $nVal = $vop - floor($vop/$vmod)*$vmod;
   return $nVal;
}


/*
*/
function gb_Div($vop, $vmod) {
   $nVal = floor($vop/$vmod);
   return $nVal;
}


/*
*/
function gb_CrossFoot($number) {
   $strNum = (string) $number;

   for ($iCrossFoot=$i=0; $i<strlen($strNum); $i++ ) {
      $iCrossFoot += $strNum{$i};
   }

   return $iCrossFoot;
} 


/*
*/
function gb_rot13($cText) {
   if (phpversion() >= "4.2") 
       return str_rot13($cText);
   else
       return $cText;
}


/* Convert text smiley into their 'cod-word'
*/
function gb_conv2Smileys($cText) {
   $asrctxt = array (':-))',  
                     ':))',               
                     ':-D',               
                     ':D',               
                     ':-)',               
                     ':)',               
                     '8-)',
                     '8)',               
                     ':P',               
                     ';-)',
                     ';)',               
                     ',-)',               
                     ',)',               
                     '?(',               
                     '8o',               
                     'X(',               
                     ':->',
                     ':>',              
                     ':-(',
                     ':(',
                     ':~(',
                     ';-(',
                     ';(');               

   $areptxt = array (':happy:',
                     ':happy:',
                     ':biggrin:',
                     ':biggrin:',
                     ':smile:',
                     ':smile:',
                     ':cool:',
                     ':cool:',
                     ':tongue:',
                     ':wink:',
                     ':wink:',
                     ':wink:',
                     ':wink:',
                     ':confused:',
                     ':eek:',
                     ':mad:',
                     ':evil:',
                     ':evil:',
                     ':frown:',
                     ':frown:',
                     ':crying:',
                     ':crying:',
                     ':crying:');

   return str_replace($asrctxt, $areptxt, $cText);
}


/* Replace smileys for images
*/
function gb_showSmileys($cText) {
   GLOBAL $su, $sl, $plugin_cf, $plugin_tx, $pth, $plugin, $cf;

   $imgPath = $pth['folder']['plugins'] . "gbook/images/";
   $imgPrefix = "<img src=\"" . $imgPath . "emi_";
   $imgPostfix = ".png\" border=\"0\" alt=\"emoticon\"".($cf['xhtml']['endtags'] == 'true' ? "/" : "").">";

   $asrctxt = array (':happy:',  
                     ':smile:',
                     ':biggrin:',
                     ':cool:',
                     ':tongue:',
                     ':wink:',
                     ':confused:',
                     ':eek:',
                     ':rolleyes:',
                     ':mad:',
                     ':evil:',
                     ':frown:',
                     ':crying:');               

   $areptxt = array ($imgPrefix."happy".$imgPostfix,
                     $imgPrefix."smile".$imgPostfix,
                     $imgPrefix."biggrin".$imgPostfix,
                     $imgPrefix."cool".$imgPostfix,
                     $imgPrefix."tongue".$imgPostfix,
                     $imgPrefix."wink".$imgPostfix,
                     $imgPrefix."confused".$imgPostfix,
                     $imgPrefix."eek".$imgPostfix,
                     $imgPrefix."rolleyes".$imgPostfix,
                     $imgPrefix."mad".$imgPostfix,
                     $imgPrefix."evil".$imgPostfix,
                     $imgPrefix."frown".$imgPostfix,
                     $imgPrefix."crying".$imgPostfix);

   return str_replace($asrctxt, $areptxt, $cText);
}


/* Generate smiley toolbar
*/
function gb_smileyToolbar() {
   $stb = "";
   $stb .= gb_InsertSmilie(':-)','smile'); 
   $stb .= gb_InsertSmilie(':-))','happy'); 
   $stb .= gb_InsertSmilie(':-D','biggrin'); 
   $stb .= gb_InsertSmilie(';-)','wink'); 
   $stb .= gb_InsertSmilie('8-)','cool'); 
   $stb .= gb_InsertSmilie(':P','tongue'); 
   $stb .= gb_InsertSmilie('8o','eek'); 
   $stb .= gb_InsertSmilie(':rolleyes:','rolleyes'); 
   $stb .= gb_InsertSmilie('?(','confused'); 
   $stb .= gb_InsertSmilie(':-(','frown'); 
   $stb .= gb_InsertSmilie(':~(','crying'); 
   $stb .= gb_InsertSmilie('X(','mad'); 
   $stb .= gb_InsertSmilie(':->','evil'); 
   return $stb;
}


/* Generate smiley button
*/
function gb_InsertSmilie($smiley, $fname) {
   GLOBAL $su, $sl, $plugin_cf, $plugin_tx, $pth, $plugin;

   $imgPath = $pth['folder']['plugins'] . "gbook/images/";
   $smLink = "<a href=\"javascript:insertText('gbmessage','" . $smiley . "');\">";
   $smLink .= tag('img src="' . $imgPath . 'emi_' . $fname . '.png" border="0" alt="emoticon"');
   $smLink .= "</a> ";

   return $smLink;
}


/* Check online for newer version (original plugin)
*/
function gb_chkVersionOnline () {
   GLOBAL $su, $sl, $plugin_cf, $plugin_tx, $pth, $plugin;

   ini_set("user_agent", "Lynx/".gb_Version()." (GBook ".gb_Version()."; Online Version Check)");
   //$fh = fopen ("http://localhost/jed/vercheck/gbookversion.php", "r");
   $fh = fopen ("http://www.qualifire.de/cmsimple/vercheck/gbookversion.php", "r");
   $gb_NewestVersion = fgets($fh);
   fclose($fh);
   
   $localVersionFile = $pth['folder']['plugins'].$plugin."/content/"."lastversion.txt";
   //echo $pth['folder']['plugins'].$plugin."/content/"."latestversion.txt";
   $fh = fopen($pth['folder']['plugins'].$plugin."/content/"."latestversion.txt", "r");
   $gb_LatestVersion = fgets($fh);
   fclose($fh);
   
   if(stripos($plugin_cf['gbook']['debug'], "true") !== false) {
      echo tag('br')."-----------------------------".tag('br');
      echo "Installed Version: ".gb_Version().tag('br');
      echo "Latest Version: ".$gb_LatestVersion.tag('br');
      echo "Newest Version: ".$gb_NewestVersion.tag('br');
      echo "-----------------------------".tag('br');
   }
   
   if ($gb_NewestVersion > $gb_LatestVersion) {
      $fh = fopen($pth['folder']['plugins'].$plugin."/content/"."latestversion.txt", "w");
      fputs($fh,$gb_NewestVersion);
      fclose($fh);
   }

   if (($gb_NewestVersion > gb_Version()) && ($gb_NewestVersion <> $gb_LatestVersion)) {
      //echo "=============================================".tag('br');
      //echo "The newest version of GBook is: " . $gb_NewestVersion . tag('br');
      //echo "=============================================".tag('br');

      gb_sendmail(
         "Gbook_".$sl."@{$_SERVER['SERVER_NAME']}",
         $plugin_cf['gbook']['info_mail_to'],
         "New version of GBook available",
         "Hello Webmaster,".tag('br')."\nthere is a new version of the plugin GBook available.");

   }
}


/* Send emails
*/
function gb_sendmail($emFrom, $emTo, $emSubj, $emBody){
   GLOBAL $su, $sl, $plugin_cf, $plugin_tx, $pth, $plugin;
   
   @mail(
      $emTo,
      '=?UTF-8?B?'.base64_encode($emSubj).'?=',
      $emBody,
      "From: ".$emFrom."\r\n"
      ."MIME-Version: 1.0\r\n"
      ."Content-Type: text/html; charset=UTF-8\r\n"
      ."Content-Transfer-Encoding: 8bit/html\r\n"
      ."X-Mailer: PHP/" . phpversion());

   if(stripos($plugin_cf['gbook']['debug'], "true") !== false) {
      echo tag('br')."-----------------------------".tag('br');
      echo "E-Mail \"$emSubj\" sent to \"$emTo\"".tag('br');
      echo "-----------------------------".tag('br');
   }
      
/*

               $mailbody = $gbname . " " . $plugin_tx['gbook']['txt_email_wrote'] . ":".tag('br')."\n";
               $mailbody .= str_repeat("-", strlen($mailbody)) . tag('br').tag('br')."\n\n";
               if (!$gbtitle == "") $mailbody .= $gbtitle . tag('br').tag('br')."\n\n";
               $mailbody .= $gbmessage .tag('br').tag('br')"\n\n";
               $gblink = "http://" . $_SERVER['HTTP_HOST'] . $_SERVER['PHP_SELF'] . "?" . $_SERVER['QUERY_STRING']; 
               $mailbody .= "<a href=\"$gblink\">$gblink</a>".tag('br')."\n";
               @mail(
                  $plugin_cf['gbook']['info_mail_to'],
                  '=?UTF-8?B?'.base64_encode("NEW: ".$gbtitle).'?=',
                  $mailbody,
                  "From: Gbook_".$sl."@{$_SERVER['SERVER_NAME']}\r\n"
                  ."MIME-Version: 1.0\r\n"
                  ."Content-Type: text/html; charset=UTF-8\r\n"
                  ."Content-Transfer-Encoding: 8bit/html\r\n"
                  ."X-Mailer: PHP/" . phpversion());

*/

	return;
}


/* Filter text according to quarantine settings
*/
function gb_chkQuarantine($cText, $tStamp) {
   GLOBAL $plugin_cf, $plugin_tx;

   $dHours = (mktime() - $tStamp) / 3600.0;

   if ($plugin_cf['gbook']['quarantine_time'] < 1.0) {
       $cPeriod = $plugin_tx['gbook']['txt_quarantine_minutes'];
       $rPeriod = $plugin_cf['gbook']['quarantine_time'] * 60.0;
   } else {
       $cPeriod = $plugin_tx['gbook']['txt_quarantine_hours'];
       $rPeriod = $plugin_cf['gbook']['quarantine_time'];
   }

   if ($dHours < $plugin_cf['gbook']['quarantine_time']) 
       return "<em>" . sprintf($plugin_tx['gbook']['txt_quarantine_notice'], $rPeriod, $cPeriod) . "</em>";
   else
       return $cText;
}


/* Check IP for blocked IPs
*/
function gb_chkBlockedIPs ($ipaddr) {
   GLOBAL $plugin_cf;

   $ipList = array();
   $ipList = explode( "|", $plugin_cf['gbook']['blocked_IPs'] );
   $retVal = false;
   foreach ($ipList as $key => $ipValue) {
       if (strpos($ipValue, "-") !== false) {
       	list($ipstart,$ipend) = explode( "-", $ipValue );
       } else {
       	$ipstart = $ipValue;
       	$ipend = "";
       }

       if (gb_chkIPRange($ipstart,$ipend,$ipaddr))
           $retVal = true;
   }
   return $retVal;
}

/*
*/
function gb_chkIPRange() {
	// args: $lowIP, $highIP, $ipaddr
	$lowIP = func_get_arg(0);
	$highIP = func_get_arg(1);
	if (empty($highIP)) 
		$highIP = $lowIP;
	if (func_num_args() < 3) {
		$ipaddr = $highIP;
		$highIP = $lowIP;
	} else {
		$ipaddr = func_get_arg(2);
	}
	$lowIP = gb_ip2hex($lowIP);
	$highIP = gb_ip2hex($highIP);
	$ipaddr = gb_ip2hex($ipaddr);
	if (($lowIP <= $ipaddr) && ($highIP >= $ipaddr))
		return true;
	else
		return false;
}


/* Check string for blocked words
*/
function gb_chkBlockedWords($cText) {
   GLOBAL $plugin_cf;

   if (preg_match('/'.$plugin_cf['gbook']['blocked_words'].'/i', $cText)) 
       return true;
   else
       return false;
}


/* Check IP for blocked domains
*/
function gb_chkBlockedDomains ($ipaddr) {
   GLOBAL $plugin_cf;

   $cHostname = @gethostbyaddr($ipaddr);
   if (empty($cHostname))
       $cHostname = "localhost";

   if (preg_match('/'.$plugin_cf['gbook']['blocked_domains'].'/i', $cHostname)) 
       return true;
   else
       return false;
}


/* Check IP for blocked countries
*/
function gb_chkBlockedCountries ($ipaddr) {
   GLOBAL $plugin_cf;

   if(stripos($plugin_cf['gbook']['debug'], "true") !== false) {
      echo tag('br')."------------------------------------------".tag('br');
      echo $ipaddr;
      echo tag('br')."------------------------------------------".tag('br');
   }

   if (empty($plugin_cf['gbook']['blocked_countries']))
       return false;

   $cCountry = ip2country($ipaddr);
   if (preg_match('/'.$plugin_cf['gbook']['blocked_countries'].'/i', $cCountry)) 
       return true;
   else
       return false;
}


/*
*/
function gb_ip2hex($ipaddr) {
	$iphex = "";
	// since cmsimple 3.0 $ipaddr can be empty
	if ($ipaddr == "")
		return $iphex;
	$iprange = explode('.',$ipaddr);
	for($i=0; $i <4; $i++)
		$iphex .= sprintf("%02X",$iprange[$i]);
	return $iphex;
}


/* Convert IP to two-letter country code
*/
function ip2country($ip) {   
  GLOBAL $pth, $plugin, $plugin_cf;

  $numbers = preg_split( "/\./", $ip);   
    
  if(stripos($plugin_cf['gbook']['debug'], "true") !== false) {
      echo tag('br')."-------------------------".tag('br');
      echo $pth['folder']['plugins'].$plugin."/include/ip_files/".$numbers[0].".php";
      echo tag('br')."-------------------------".tag('br');
	}
    
  if (file_exists($pth['folder']['plugins'].$plugin."/include/ip_files/".$numbers[0].".php")) {
      include($pth['folder']['plugins'].$plugin."/include/ip_files/".$numbers[0].".php");
      // include(plugins/gbook/include/ip_files/127.php);
      // include("W:/Websites/local/cmsimple3_0/plugins/gbook/include/ip_files/".$numbers[0].".php");
      $code=($numbers[0] * 16777216) + ($numbers[1] * 65536) + ($numbers[2] * 256) + ($numbers[3]);   
      foreach($ranges as $key => $value){
         if($key<=$code){
           if($ranges[$key][0]>=$code){ $two_letter_country_code=$ranges[$key][1];break; }
         }
      } 

  } else {
     if (stripos($plugin_cf['gbook']['debug'], "true") !== false) {
          echo tag('br')."-------------------------".tag('br');
          echo "Include-File not found.";
          echo tag('br')."-------------------------".tag('br');
     }
     $two_letter_country_code="00";
  }

    
  if ($two_letter_country_code==""){$two_letter_country_code="00";}
  return $two_letter_country_code;
} 


/* Check language variables and return found errors
*/
function gb_chkLangVars () {
    GLOBAL $plugin_tx;
    
    $cProblems = "";
    if (empty($plugin_tx['gbook']['mnu_main']))
        $cProblems .= 'mnu_main, ';
    if (empty($plugin_tx['gbook']['mnu_css']))
        $cProblems .= 'mnu_css, ';
    if (empty($plugin_tx['gbook']['mnu_config']))
        $cProblems .= 'mnu_config, ';
    if (empty($plugin_tx['gbook']['mnu_language']))
        $cProblems .= 'mnu_language, ';
    if (empty($plugin_tx['gbook']['mnu_help']))
        $cProblems .= 'mnu_help, ';
    if (empty($plugin_tx['gbook']['txt_newentry']))
        $cProblems .= 'txt_newentry, ';
    if (empty($plugin_tx['gbook']['txt_captcha']))
        $cProblems .= 'txt_captcha, ';
    if (empty($plugin_tx['gbook']['txt_wrong_captcha']))
        $cProblems .= 'txt_wrong_captcha, ';
    if (empty($plugin_tx['gbook']['txt_blocked_ip']))
        $cProblems .= 'txt_blocked_ip, ';
    if (empty($plugin_tx['gbook']['txt_blocked_domain']))
        $cProblems .= 'txt_blocked_domain, ';
    if (empty($plugin_tx['gbook']['txt_blocked_country']))
        $cProblems .= 'txt_blocked_country, ';
    if (empty($plugin_tx['gbook']['txt_spam_found']))
        $cProblems .= 'txt_spam_found, ';
    if (empty($plugin_tx['gbook']['txt_name']))
        $cProblems .= 'txt_name, ';
    if (empty($plugin_tx['gbook']['txt_email']))
        $cProblems .= 'txt_email, ';
    if (empty($plugin_tx['gbook']['txt_website']))
        $cProblems .= 'txt_website, ';
    if (empty($plugin_tx['gbook']['txt_title']))
        $cProblems .= 'txt_title, ';
    if (empty($plugin_tx['gbook']['txt_message']))
        $cProblems .= 'txt_message, ';
    if (empty($plugin_tx['gbook']['txt_publishing']))
        $cProblems .= 'txt_publishing, ';
    if (empty($plugin_tx['gbook']['btn_submit']))
        $cProblems .= 'btn_submit, ';
    if (empty($plugin_tx['gbook']['btn_cancel']))
        $cProblems .= 'btn_cancel, ';
    if (empty($plugin_tx['gbook']['lnk_prev_page']))
        $cProblems .= 'lnk_prev_page, ';
    if (empty($plugin_tx['gbook']['lnk_next_page']))
        $cProblems .= 'lnk_next_page, ';
    if (empty($plugin_tx['gbook']['lnk_first_page']))
        $cProblems .= 'lnk_first_page, ';
    if (empty($plugin_tx['gbook']['lnk_last_page']))
        $cProblems .= 'lnk_last_page, ';
    if (empty($plugin_tx['gbook']['txt_change_data']))
        $cProblems .= 'txt_change_data, ';
    if (empty($plugin_tx['gbook']['txt_mandatory_hint']))
        $cProblems .= 'txt_mandatory_hint, ';
    if (empty($plugin_tx['gbook']['txt_mandatory_alert']))
        $cProblems .= 'txt_mandatory_alert, ';
    if (empty($plugin_tx['gbook']['txt_email_wrote']))
        $cProblems .= 'txt_email_wrote, ';
    if (empty($plugin_tx['gbook']['txt_thankmail_subject']))
        $cProblems .= 'txt_thankmail_subject, ';
    if (empty($plugin_tx['gbook']['txt_thankmail_body']))
        $cProblems .= 'txt_thankmail_body, ';
    if (empty($plugin_tx['gbook']['txt_offline_hint']))
        $cProblems .= 'txt_offline_hint, ';
    if (empty($plugin_tx['gbook']['txt_incorrect_email']))
        $cProblems .= 'txt_incorrect_email, ';
    if (empty($plugin_tx['gbook']['txt_quarantine_notice']))
        $cProblems .= 'txt_quarantine_notice, ';
    if (empty($plugin_tx['gbook']['txt_quarantine_hours']))
        $cProblems .= 'txt_quarantine_hours, ';
    if (empty($plugin_tx['gbook']['txt_quarantine_minutes']))
        $cProblems .= 'txt_quarantine_minutes, ';
    if (empty($plugin_tx['gbook']['txt_bbcode']))
        $cProblems .= 'txt_bbcode, ';
    if (empty($plugin_tx['gbook']['bbcode_page']))
        $cProblems .= 'bbcode_page, ';
    if (empty($plugin_tx['gbook']['txt_rules']))
        $cProblems .= 'txt_rules, ';
    if (empty($plugin_tx['gbook']['rules_page']))
        $cProblems .= 'rules_page, ';
    if (empty($plugin_tx['gbook']['txt_message_limit']))
        $cProblems .= 'txt_message_limit, ';
    if (empty($plugin_tx['gbook']['max_chars_hint']))
        $cProblems .= 'max_chars_hint, ';
    if (empty($plugin_tx['gbook']['txt_read_faq']))
        $cProblems .= 'txt_read_faq, ';
    if (empty($plugin_tx['gbook']['txt_read_faq_b']))
        $cProblems .= 'txt_read_faq_b, ';

    if (empty($cProblems))
        return "";
    else
        return "<b>WARNING:</b>".tag('br')."The following <i>language variables</i> are empty:".tag('br') . $cProblems . tag('br')."&nbsp;".tag('br');  
}


/* Check config variables and return found errors
*/
function gb_chkConfigVars () {
    GLOBAL $plugin_cf;
    
    $cProblems = "";
    if (empty($plugin_cf['gbook']['date_format']))
        $cProblems .= 'date_format, ';
    if (empty($plugin_cf['gbook']['time_format']))
        $cProblems .= 'time_format, ';
    if (empty($plugin_cf['gbook']['captcha']))
        $cProblems .= 'captcha, ';
    if (empty($plugin_cf['gbook']['ucase_captcha']))
        $cProblems .= 'ucase_captcha, ';
    if (empty($plugin_cf['gbook']['ask_for_email']))
        $cProblems .= 'ask_for_email, ';
    if (empty($plugin_cf['gbook']['ask_for_website']))
        $cProblems .= 'ask_for_website, ';
    if (empty($plugin_cf['gbook']['ask_for_title']))
        $cProblems .= 'ask_for_title, ';
    if (empty($plugin_cf['gbook']['ask_for_zipncity']))
        $cProblems .= 'ask_for_zipncity, ';
    if (empty($plugin_cf['gbook']['ask_for_publishing']))
        $cProblems .= 'ask_for_publishing, ';
    if (empty($plugin_cf['gbook']['mandatory_title']))
        $cProblems .= 'mandatory_title, ';
    if (empty($plugin_cf['gbook']['mandatory_email']))
        $cProblems .= 'mandatory_email, ';
    if (empty($plugin_cf['gbook']['mandatory_website']))
        $cProblems .= 'mandatory_website, ';
    if (empty($plugin_cf['gbook']['mandatory_zipncity']))
        $cProblems .= 'mandatory_zipncity, ';
    if (empty($plugin_cf['gbook']['message_width']))
        $cProblems .= 'message_width, ';
    if (empty($plugin_cf['gbook']['remove_html']))
        $cProblems .= 'remove_html, ';
    if (empty($plugin_cf['gbook']['items_per_page']))
        $cProblems .= 'items_per_page, ';
    if (empty($plugin_cf['gbook']['num_of_pages']))
        $cProblems .= 'num_of_pages, ';
    if (empty($plugin_cf['gbook']['info_mail']))
        $cProblems .= 'info_mail, ';
    if (empty($plugin_cf['gbook']['info_mail_to']))
        $cProblems .= 'info_mail_to, ';
    if (empty($plugin_cf['gbook']['thank_mail']))
        $cProblems .= 'thank_mail, ';
    if (empty($plugin_cf['gbook']['thank_sendfrom']))
        $cProblems .= 'thank_sendfrom, ';
    if (empty($plugin_cf['gbook']['new_entries']))
        $cProblems .= 'new_entries, ';
    if (empty($plugin_cf['gbook']['show_creator']))
        $cProblems .= 'show_creator, ';
    if (empty($plugin_cf['gbook']['show_narrowlink']))
        $cProblems .= 'show_narrowlink, ';
    if (empty($plugin_cf['gbook']['show_email']))
        $cProblems .= 'show_email, ';
    if (empty($plugin_cf['gbook']['show_website']))
        $cProblems .= 'show_website, ';
    if (empty($plugin_cf['gbook']['show_ip_addr']))
        $cProblems .= 'show_ip_addr, ';
    if (empty($plugin_cf['gbook']['store_ip_addr']))
        $cProblems .= 'store_ip_addr, ';
    if (empty($plugin_cf['gbook']['use_smileys']))
        $cProblems .= 'use_smileys, ';
    if (empty($plugin_cf['gbook']['blocked_words']))
        $cProblems .= 'blocked_words, ';
    if (empty($plugin_cf['gbook']['blocked_IPs']))
        $cProblems .= 'blocked_IPs, ';
    if (empty($plugin_cf['gbook']['blocked_domains']))
        $cProblems .= 'blocked_domains, ';
    /* if (empty($plugin_cf['gbook']['blocked_countries']))
        $cProblems .= 'blocked_countries, '; */ //optional
    if (empty($plugin_cf['gbook']['common_guestbook']))
        $cProblems .= 'common_guestbook, ';
    if (empty($plugin_cf['gbook']['quarantine_time']) && $plugin_cf['gbook']['quarantine_time'] != '0')
        $cProblems .= 'quarantine_time, ';
    if (empty($plugin_cf['gbook']['allow_bbcode']))
        $cProblems .= 'allow_bbcode, ';
    if (empty($plugin_cf['gbook']['show_bbcode_hint']))
        $cProblems .= 'show_bbcode_hint, ';
    if (empty($plugin_cf['gbook']['message_max_chars']))
        $cProblems .= 'message_max_chars, ';
    if (empty($plugin_cf['gbook']['show_faq_hint']))
        $cProblems .= 'show_faq_hint, ';
    if (empty($plugin_cf['gbook']['faq_page_name']))
        $cProblems .= 'faq_page_name, ';
    if (empty($plugin_cf['gbook']['chceck_config']))
        $cProblems .= 'chceck_config, ';


    if (empty($cProblems))
        return "";
    else
        return "<b>WARNING:</b>".tag('br')."The following <i>configuration variables</i> are empty:".tag('br') . $cProblems . tag('br')."&nbsp;".tag('br');  
}


/* Removes html and forbidden text from string and encode htmlentities...
*/
function gb_RemoveHtml($cText) {
  global $plugin_cf;
  
  $replacer = "|~"; //warning, do not play with this ;)
  if(!empty($plugin_cf['gbook']['semicolon_replacer_sequence']))
    if(strlen($plugin_cf['gbook']['semicolon_replacer_sequence']) > 1)
      $replacer = $plugin_cf['gbook']['semicolon_replacer_sequence'];

  $sText = str_replace(";",",", $cText);
  
  $asrctxt = array ("'<script[^>]*?>.*?</script>'si",  // Strip out javascript
                "'<[\/\!]*?[^<>]*?>'si",           // Strip out HTML tags
                "'([\r\n])[\s]+'",                 // Strip out white space
                /* "'&(quot|#34);'i",                 // Replace HTML entities
                "'&(amp|#38);'i",
                "'&(lt|#60);'i",
                "'&(gt|#62);'i",
                "'&(nbsp|#160);'i",
                "'&(iexcl|#161);'i",
                "'&(cent|#162);'i",
                "'&(pound|#163);'i",
                "'&(copy|#169);'i", */ //pointless...
                "'#cmsimple'si" /*,
                "'&#(\d+);'e" */                    // evaluate as php //pointless
                );

  $areptxt = array ("",
                 "",
                 "\\1",
                 /* "\"",
                 "&",
                 "<",
                 ">",
                 " ",
                 chr(161),
                 chr(162),
                 chr(163),
                 chr(169), */
                 "#<>cmsimple" /*,
                 "chr(\\1)" */
                 );

  $sText = preg_replace($asrctxt, $areptxt, $sText);
  $sText = htmlentities($sText, ENT_QUOTES | ENT_SUBSTITUTE | ENT_DISALLOWED | ENT_XHTML, 'UTF-8');
  $sText = str_replace(";",$replacer, $sText); //replace semicolon in entities and later convert them back (TODO: char sequence in config?)
  return $sText;
}

/* ...extended version for admin
*/
function gb_RemoveHtmlEx($cText) {
  $sText = gb_RemoveHtml($cText);
  $sText = str_replace(chr(13).chr(10),tag('br'), $sText);
  $sText = str_replace(chr(13),tag('br'), $sText);
  $sText = str_replace(chr(10),tag('br'), $sText);
  return $sText;
}

/* Restores string with htmlentities (and encoded ';') to regular text
*/
function gb_restoreHtml($cText, $decodeEntities = true) {
  global $plugin_cf;
  
  $replacer = "|~"; //warning, do not play with this ;)
  if(!empty($plugin_cf['gbook']['semicolon_replacer_sequence']))
    if(strlen($plugin_cf['gbook']['semicolon_replacer_sequence']) > 1)
      $replacer = $plugin_cf['gbook']['semicolon_replacer_sequence'];

  $sText = str_replace($replacer,";", $cText);
  if($decodeEntities == true)
    $sText = html_entity_decode($sText, ENT_QUOTES | ENT_XHTML, 'UTF-8');

  $sText = str_replace(tag('br'),"\n", $sText);

  return $sText;  
}


/* Creates HTML page output from contents of target file
*/
function gb_returnContents($what) {
  GLOBAL $pth;
  
  $base = basename(dirname(__FILE__),"/");
  $file = $pth['folder']['plugins'].$base."/include/" . $what . ".inc";
  if(!$contents = file_get_contents($file))
    return "<html><head><title>Error</title></head><body>".tag('br').tag('hr')."ERROR: Cannot open file ($file)".tag('hr').tag('br')."</body></html>";
  return $contents;
}

?>
