<?php
/* utf8-marker = äöüß */
/*

Language File for CMSimple GBook plugin
© 2006-2007 - Joachim Barthel - www.qualifire.de/cmsimple/en
---------------------------------------------------------------------
Disclaimer:   No warranties at all, use on your own risk !
---------------------------------------------------------------------
Requirements: - CMSimple 2.5 is installed and running
              - The plugin loader from cmsimpleplugins.svarrer.dk 
                is installed and working
              - GBook plugin is installed and working
---------------------------------------------------------------------
Feedback to:  jbarthel@qualifire.de
---------------------------------------------------------------------
Thanks to Martin Sereday for translating this file!
---------------------------------------------------------------------

*/

$plugin_tx['gbook']['mnu_main']="Príspevky";
$plugin_tx['gbook']['mnu_css']="Vzhľad";
$plugin_tx['gbook']['mnu_config']="Konfigurácia";
$plugin_tx['gbook']['mnu_language']="Jazyk";
$plugin_tx['gbook']['mnu_help']="Pomoc";
$plugin_tx['gbook']['txt_newentry']="Pridaj svoj príspevok";
$plugin_tx['gbook']['txt_captcha']="Opíšte overovací kód: ";
$plugin_tx['gbook']['txt_wrong_captcha']="Chybný overovací kód!";
$plugin_tx['gbook']['txt_blocked_ip']="Your IP address is blocked. Your message was not stored.";
$plugin_tx['gbook']['txt_blocked_domain']="Your domain address is blocked. Your message was not stored.";
$plugin_tx['gbook']['txt_blocked_country']="Your contry is blocked. Your message was not stored.";
$plugin_tx['gbook']['txt_spam_found']="Našli sa nepovolené výrazy (spam). Obsah nebol uložený.";
$plugin_tx['gbook']['txt_name']="Meno";
$plugin_tx['gbook']['txt_email']="E-mail";
$plugin_tx['gbook']['txt_website']="Www";
$plugin_tx['gbook']['txt_zip']="PSČ";
$plugin_tx['gbook']['txt_city']="Mesto";
$plugin_tx['gbook']['txt_title']="Názov príspevku";
$plugin_tx['gbook']['txt_message']="Príspevok";
$plugin_tx['gbook']['txt_publishing']="Súhlasím, že môj príspevok môže byť publikovaný na tejto stránke alebo v tlači.";
$plugin_tx['gbook']['btn_submit']=" Odoslať ";
$plugin_tx['gbook']['btn_cancel']="Zrušiť";
$plugin_tx['gbook']['lnk_prev_page']="< Predošlý";
$plugin_tx['gbook']['lnk_next_page']="Ďalší >";
$plugin_tx['gbook']['lnk_first_page']="<< Začiatok";
$plugin_tx['gbook']['lnk_last_page']="Koniec >>";
$plugin_tx['gbook']['txt_change_data']="Uprav obsah príspevkov: Jeden príspevok v jednom riadku, Polia oddelené ; (bodko-čiarkou)";
$plugin_tx['gbook']['txt_mandatory_hint']="povinné údaje, musia byť vyplnené";
$plugin_tx['gbook']['txt_mandatory_alert']="Neúplný údaj!";
$plugin_tx['gbook']['txt_email_wrote']="píše";
$plugin_tx['gbook']['txt_thankmail_subject']="Tvoj príspevok v knihe návštev";
$plugin_tx['gbook']['txt_thankmail_body']="Ahoj %s,<br/><br/>veľmi pekne ďakujeme za Tvoj príspevok do knihy návštev<br/><br/>S vďakou<br/><br/>Webmaster<br/>--------------------------<br/>%s";
$plugin_tx['gbook']['txt_offline_hint']="<hr/><b>Informácia:</b><br/>Z dôvodu momentálnej údržby stránky nie je možné posielať príspevky.<hr/><br/>";
$plugin_tx['gbook']['txt_incorrect_email']="E-mailová adresa je chybná.\\nSkontrolujte ju!";
$plugin_tx['gbook']['txt_quarantine_notice']="Vaša správa bola prijatá<br/>a bude skontrolovaná.<br/>Čas na overenie %s hodín.";
$plugin_tx['gbook']['txt_quarantine_hours']="hodina(y)";
$plugin_tx['gbook']['txt_quarantine_minutes']="minuta(y)";
$plugin_tx['gbook']['txt_bbcode']="Povolené formátovacie značky";
$plugin_tx['gbook']['bbcode_page']="gb_bbcode_sk";
$plugin_tx['gbook']['txt_rules']="Pravidlá";
$plugin_tx['gbook']['rules_page']="gb_rules_sk";
$plugin_tx['gbook']['txt_message_limit']="Správa presahuje povolený limit znakov!";
$plugin_tx['gbook']['max_chars_hint']="Zostávajúci počet znakov:";
$plugin_tx['gbook']['txt_read_faq']="Pred pridaním príspevku odporúčame prečítať sekciu:";
$plugin_tx['gbook']['txt_read_faq_b']="Najčastejších otázok - FAQ";


/* --- config hints --- */
$plugin_tx['gbook']['cf_date_format']="Formát zobrazovaných dátumov. Podľa PHP Date().";
$plugin_tx['gbook']['cf_time_format']="Formát zobrazovaného času.";
$plugin_tx['gbook']['cf_captcha']="Zapnúť verifikáciu captcha kódom, True/False.";
$plugin_tx['gbook']['cf_image_captcha']="Použiť obrázkové captcha. Odporúčané =True.";
$plugin_tx['gbook']['cf_numeric_captcha']="Použiť iba číselné captcha. (v obrázkovom captcha, True/False)";
$plugin_tx['gbook']['cf_ucase_captcha']="Použiť veľké písmená v captcha. (v obrázkovom captcha, True/False)";
$plugin_tx['gbook']['cf_ask_for_email']="Zobraziť pole pre zadanie emailu, True/False.";
$plugin_tx['gbook']['cf_ask_for_website']="Zobraziť pole pre zadanie webstránky, True/False.";
$plugin_tx['gbook']['cf_ask_for_zipncity']="Zobraziť pole pre zadanie mesta a PSČ, True/False.";
$plugin_tx['gbook']['cf_ask_for_title']="Zobraziť pole pre zadanie nadpisu príspevku, True/False.";
$plugin_tx['gbook']['cf_ask_for_publishing']="Zobraziť checkbox pre súhlas s publikovaním, True/False.";
$plugin_tx['gbook']['cf_mandatory_title']="Vyplnenie nadpisu príspevku je povinné, True/False.";
$plugin_tx['gbook']['cf_mandatory_email']="Vyplnenie emailu je povinné, True/False.";
$plugin_tx['gbook']['cf_mandatory_website']="Vyplnenie webstránky je povinné, True/False.";
$plugin_tx['gbook']['cf_mandatory_zipncity']="Vyplnenie mesta a PSČ je povinné, True/False.";
$plugin_tx['gbook']['cf_message_width']="Šírka poľa pre text správy.";
$plugin_tx['gbook']['cf_remove_html']="Odstrániť html značky zo správy, True/False.";
$plugin_tx['gbook']['cf_items_per_page']="Počet správ zobrazených na jednej stránke.";
$plugin_tx['gbook']['cf_num_of_pages']="Na koľko stránok vpred a vzad je zobrazený odkaz.";
$plugin_tx['gbook']['cf_info_mail']="Odosielanie informačného emailu pri pridaní príspevku, True/False.";
$plugin_tx['gbook']['cf_info_mail_to']="Adresa komu zaslať informačný email.";
$plugin_tx['gbook']['cf_thank_mail']="Zasieľanie ďakovného emailu pri pridaní príspevku, True/False.";
$plugin_tx['gbook']['cf_thank_sendfrom']="Odosielateľ ďakovného emailu.";
$plugin_tx['gbook']['cf_new_entries']="Povoliť nové príspevky, True/False. (napr. pre údržbu)";
$plugin_tx['gbook']['cf_show_creator']="Zobrazovať info a odkaz na tvorcu pluginu.";
$plugin_tx['gbook']['cf_show_narrowlink']="Zapnutie navigačných odkazov \"< Vpred\" a \"Vzad >\", True/False.";
$plugin_tx['gbook']['cf_show_email']="Zobraozovať email prispievateľa (pozri ask_for_email), True/False.";
$plugin_tx['gbook']['cf_show_website']="Zobrazovať webstránku prispievateľa (pozri ask_for_website), True/False.";
$plugin_tx['gbook']['cf_show_zipncity']="Zobrazovať mesto a PSČ prispievateľa (pozri ask_for_zipncity), True/False.";
$plugin_tx['gbook']['cf_show_ip_addr']="Zobrazovať IP adresu prispievateľa (pozri store_ip_addr), True/False.";
$plugin_tx['gbook']['cf_store_ip_addr']="Ukladať IP adresu prispievateľa, True/False.";
$plugin_tx['gbook']['cf_use_smileys']="Použitie grafických smajlíkov, Tru/False.";
$plugin_tx['gbook']['cf_blocked_words']="Zakázané slová. Možno tu použiť regulárne výrazy.";
$plugin_tx['gbook']['cf_blocked_IPs']="Zakázať príspevky od návštevníka s touto IP adresou (IP rozsahy).";
$plugin_tx['gbook']['cf_blocked_domains']="Zákázané domény. Možno tu použiť regulárne výrazy.";
$plugin_tx['gbook']['cf_blocked_countries']="Zakázané krajiny. Možno tu použiť regulárne výrazy.";
$plugin_tx['gbook']['cf_common_guestbook']="Používať iba jeden spoločný súbor obsahu pre všetky jazyky, True/False.";
$plugin_tx['gbook']['cf_quarantine_time']="Doba karantény príspevku v hodinách, 0=vypnuté. Počas karantény sa zobrazí text \$plugin_tx['gbook']['txt_quarantine_notice'].";
$plugin_tx['gbook']['cf_admin_name_qualifier']="Špeciálna sekvencia znakov, ktorá môže byť použitá na to, aby sa aplikovalo špecifické formátovanie v novom príspevku. Vložte túto sekvenciu na začiatok mena prispievateľa pre použitie špecifického formátovania (Adminove príspevky).";
$plugin_tx['gbook']['cf_allow_bbcode']="Povoliť bbcode formátovanie v príspevkoch, True/False.";
$plugin_tx['gbook']['cf_show_bbcode_hint']="Zobraziť lin na vyskakovacie okno s nápovedou k bbcode značkám, True/False.";
$plugin_tx['gbook']['cf_show_faq_hint']="Zobraziť odkaz na FAQ stránku na začiatku guestbooku (napr. pre redukciu opakovaných otázok), True/False";
$plugin_tx['gbook']['cf_faq_page_name']="Názov FAQ stránky (v obsahu).";
$plugin_tx['gbook']['cf_message_max_chars']="Limit znakov správy.";
$plugin_tx['gbook']['cf_chceck_config']="Zapnúť kontrolu konfiguračných a jazykových premenných, True/False.";
$plugin_tx['gbook']['cf_debug']="Aktivovať debug mód. Zobrazuje rozšírené pomocné inrormácie. True/False.";
$plugin_tx['gbook']['cf_check_version']="Konrolovať novšiu verziu guestbooku (originál od Qualifire).";
$plugin_tx['gbook']['cf_raw_edit']="Povolit cisto textovu editaciu datoveho suboru v adminovi.";
?>
